import math

def CompareP1Cells(one, two, three):
    """Compare three p1 cells - happy if we agree within 1 angstrom
    or degree"""
    meanA = (one.getA() + two.getA() + three.getA()) / 3.0
    meanB = (one.getB() + two.getB() + three.getB()) / 3.0
    meanC = (one.getC() + two.getC() + three.getC()) / 3.0
    meanAlpha = (one.getAlpha() + two.getAlpha() + three.getAlpha()) / 3.0
    meanBeta = (one.getBeta() + two.getBeta() + three.getBeta()) / 3.0
    meanGamma = (one.getGamma() + two.getGamma() + three.getGamma()) / 3.0

    if math.fabs(one.getA() - meanA) > 1.0 or \
           math.fabs(two.getA() - meanA) > 1.0 or \
           math.fabs(three.getA() - meanA) > 1.0:

        return 1
    if math.fabs(one.getB() - meanB) > 1.0 or \
           math.fabs(two.getB() - meanB) > 1.0 or \
           math.fabs(three.getB() - meanB) > 1.0:

        return 1
    if math.fabs(one.getC() - meanC) > 1.0 or \
           math.fabs(two.getC() - meanC) > 1.0 or \
           math.fabs(three.getC() - meanC) > 1.0:

        return 1
    if math.fabs(one.getAlpha() - meanAlpha) > 1.0 or \
           math.fabs(two.getAlpha() - meanAlpha) > 1.0 or \
           math.fabs(three.getAlpha() - meanAlpha) > 1.0:

        return 1
    if math.fabs(one.getBeta() - meanBeta) > 1.0 or \
           math.fabs(two.getBeta() - meanBeta) > 1.0 or \
           math.fabs(three.getBeta() - meanBeta) > 1.0:

        return 1
    if math.fabs(one.getGamma() - meanGamma) > 1.0 or \
           math.fabs(two.getGamma() - meanGamma) > 1.0 or \
           math.fabs(three.getGamma() - meanGamma) > 1.0:

        return 1

    # reaching here implies happyness so
    return 0
